using System;

namespace BindingList_Test
{
    using System.ComponentModel;

    public class Person : System.ComponentModel.INotifyPropertyChanged
    {
        private int _id;
        private string _firstName;
        private string _lastName;


        public int ID
        {
            get
            {
                return this._id;
            }
            set
            {
                if (this._id != value)
                {
                    this._id = value;
                    this.OnPropertyChanged(new PropertyChangedEventArgs("ID"));
                }
            }
        }

        public string FirstName
        {
            get
            {
                return this._firstName;
            }
            set
            {
                if (this._firstName != value)
                {
                    this._firstName = value;
                    this.OnPropertyChanged(new PropertyChangedEventArgs("FirstName"));
                }
            }
        }

        public string LastName
        {
            get
            {
                return this._lastName;
            }
            set
            {
                if (this._lastName != value)
                {
                    this._lastName = value;
                    this.OnPropertyChanged(new PropertyChangedEventArgs("LastName"));
                }
            }
        }


        public Person(int id, string firstName, string lastName)
        {
            this._id = id;
            this._firstName = firstName;
            this._lastName = lastName;
        }


        /// <summary>
        /// Occurs when a property value changes.
        /// </summary>
        public event PropertyChangedEventHandler PropertyChanged;


        /// <summary>
        /// Raises the PropertyChanged event.
        /// </summary>
        protected virtual void OnPropertyChanged(PropertyChangedEventArgs e)
        {
            if (this.PropertyChanged != null)
            {
                this.PropertyChanged(this, e);
            }
        }
    }
}
